VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EventHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'find a note attached to theClassView which text starts with theTitle
Function FindNoteWithTitle(theClassView As RoseClassView, theTitle As String) As RoseNoteView
       Dim i As Integer
       Dim theNote As RoseNoteView
       
        For i = 1 To theClassView.GetAttachedNotes.Count
            Set theNote = theClassView.GetAttachedNotes.GetAt(i)
            If InStr(1, theNote.Text, theTitle) = 1 Then
              Set FindNoteWithTitle = theNote
              Exit Function
            End If
        Next i
        Set FindNoteWithTitle = Nothing
End Function

'Populate theNote with theTitle followed by all the properties of theClass
Sub PopulateNote(theClass As RoseClass, theNote As RoseNoteView, theTitle As String)
    Dim i As Integer
    
    Dim thePropColl As RosePropertyCollection
    Dim theProperty As RoseProperty
    Dim thisLine As String
    Dim maxLine As String
    Set thePropColl = theClass.GetAllProperties
    maxLine = theTitle
    
    theNote.Text = theTitle + Chr(13) + Chr(10)
    For i = 1 To thePropColl.Count
        Set theProperty = thePropColl.GetAt(i)
        thisLine = Chr(13) + Chr(10) + _
        "[" + theProperty.ToolName + "] " + _
        theProperty.Name + " = " + _
        theProperty.Value
        If Len(thisLine) > Len(maxLine) Then maxLine = thisLine
        theNote.Text = theNote.Text + thisLine
    Next i

    'euristic resizing of the note based on the text
    theNote.Font.FaceName = "Arial"
    theNote.Font.Size = 10
    theNote.Height = 52 * thePropColl.Count
    theNote.Width = 24 * Len(maxLine)

End Sub

'populate a note with updated properties values for the modified class
Sub OnModifiedModelElementEx(objRoseApp As RoseApplication, objItem As RoseItem, intReason As Integer, vnt As Variant)

Dim theProperty As RoseProperty
Dim theClass As RoseClass
Dim theDiagram  As RoseClassDiagram
Dim theClassView As RoseClassView
Dim theNote As RoseNoteView
Dim theAnchor As RoseItemView
Dim theTitle As String
Dim isadded As Boolean


'try not to execute if not needed -- reason 122 indicates a property change
If (objItem.IdentifyClass = "Class" And intReason = 122) Then
        Set theClass = objItem
        'identify or create the diagram in the package containing the class
        Set theDiagram = theClass.ParentCategory.ClassDiagrams.GetFirst("Property Overview")
        If theDiagram Is Nothing Then
           Set theDiagram = theClass.ParentCategory.AddClassDiagram("Property Overview")
        End If
        
        'identify or create the class view
        If Not theDiagram.Exists(theClass) Then
           isadded = theDiagram.AddClass(theClass)
        End If
        Set theClassView = theDiagram.GetViewFrom(theClass)
        
        theTitle = "Properties:"
        
        'identify or create the note
        Set theNote = FindNoteWithTitle(theClassView, theTitle)
        If theNote Is Nothing Then
           Set theNote = theDiagram.AddNoteView(theTitle, 2)
           Set theAnchor = theNote.AddAttachmentToView(theClassView, "Display Properties")
        End If
        'populate the note with a dump of all properties
        Call PopulateNote(theClass, theNote, theTitle)
        theDiagram.AutosizeAll
        theDiagram.Layout
End If


End Sub

